
_Init:

;electronique_chenillard_012_16f628.mpas,42 :: 		begin
;electronique_chenillard_012_16f628.mpas,43 :: 		CMCON := 7;        // comparators off
	MOVLW      7
	MOVWF      CMCON+0
;electronique_chenillard_012_16f628.mpas,44 :: 		OPTION_REG := 0;
	CLRF       OPTION_REG+0
;electronique_chenillard_012_16f628.mpas,45 :: 		OPTION_REG.NOT_RBPU := 0;   // enable pullups
	BCF        OPTION_REG+0, 7
;electronique_chenillard_012_16f628.mpas,46 :: 		TRISA := %01010000;  // PORTA as output, but RA4 and RA6 as input
	MOVLW      80
	MOVWF      TRISA+0
;electronique_chenillard_012_16f628.mpas,47 :: 		TRISB := %11000000;  // RB0..RB5 as output, RB6..RB7 as input
	MOVLW      192
	MOVWF      TRISB+0
;electronique_chenillard_012_16f628.mpas,48 :: 		PORTA := %00000000;  // clear porta
	CLRF       PORTA+0
;electronique_chenillard_012_16f628.mpas,49 :: 		PORTB := %11000000;  // clear portb
	MOVLW      192
	MOVWF      PORTB+0
;electronique_chenillard_012_16f628.mpas,50 :: 		INTCON := 0;
	CLRF       INTCON+0
;electronique_chenillard_012_16f628.mpas,51 :: 		INTCON.GIE  := 1;  // enable global ints
	BSF        INTCON+0, 7
;electronique_chenillard_012_16f628.mpas,52 :: 		INTCON.RBIE := 1;  // enable RB4..RB7 int
	BSF        INTCON+0, 3
;electronique_chenillard_012_16f628.mpas,53 :: 		INTCON.RBIF := 0;
	BCF        INTCON+0, 0
;electronique_chenillard_012_16f628.mpas,54 :: 		iMode := 0;
	CLRF       _iMode+0
;electronique_chenillard_012_16f628.mpas,55 :: 		bStop := 0;
	CLRF       _bStop+0
;electronique_chenillard_012_16f628.mpas,56 :: 		bStart := 0;
	CLRF       _bStart+0
;electronique_chenillard_012_16f628.mpas,57 :: 		bStarted := false;
	CLRF       _bStarted+0
;electronique_chenillard_012_16f628.mpas,58 :: 		bRunning := false;
	CLRF       _bRunning+0
;electronique_chenillard_012_16f628.mpas,59 :: 		end;
	RETURN
; end of _Init

_Delay_Save:

;electronique_chenillard_012_16f628.mpas,62 :: 		begin
;electronique_chenillard_012_16f628.mpas,63 :: 		EEProm_Write(0, Lo(iDelayStart));
	CLRF       FARG_EEPROM_Write_address+0
	MOVF       _iDelayStart+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_chenillard_012_16f628.mpas,64 :: 		EEProm_Write(1, Hi(iDelayStart));
	MOVLW      1
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _iDelayStart+1, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_chenillard_012_16f628.mpas,65 :: 		EEProm_Write(2, Lo(iDelayStop));
	MOVLW      2
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _iDelayStop+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_chenillard_012_16f628.mpas,66 :: 		EEProm_Write(3, Hi(iDelayStop));
	MOVLW      3
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _iDelayStop+1, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_chenillard_012_16f628.mpas,67 :: 		end;
	RETURN
; end of _Delay_Save

_Delay_Load:

;electronique_chenillard_012_16f628.mpas,72 :: 		begin
;electronique_chenillard_012_16f628.mpas,73 :: 		tmpLo := EEProm_Read(0);
	CLRF       FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      Delay_Load_tmpLo+0
;electronique_chenillard_012_16f628.mpas,74 :: 		tmpHi := EEProm_Read(1);
	MOVLW      1
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      Delay_Load_tmpHi+0
;electronique_chenillard_012_16f628.mpas,75 :: 		if tmpHi = $FF then tmpHi := 0;
	MOVF       R0+0, 0
	XORLW      255
	BTFSS      STATUS+0, 2
	GOTO       L__Delay_Load4
	CLRF       Delay_Load_tmpHi+0
L__Delay_Load4:
;electronique_chenillard_012_16f628.mpas,76 :: 		iDelayStart := (256 * tmpHi) + tmpLo;
	MOVF       Delay_Load_tmpHi+0, 0
	MOVWF      _iDelayStart+1
	CLRF       _iDelayStart+0
	MOVF       Delay_Load_tmpLo+0, 0
	ADDWF      _iDelayStart+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDelayStart+1, 1
;electronique_chenillard_012_16f628.mpas,77 :: 		tmpLo := EEProm_Read(2);
	MOVLW      2
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      Delay_Load_tmpLo+0
;electronique_chenillard_012_16f628.mpas,78 :: 		tmpHi := EEProm_Read(3);
	MOVLW      3
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      Delay_Load_tmpHi+0
;electronique_chenillard_012_16f628.mpas,79 :: 		if tmpHi = $FF then tmpHi := 0;
	MOVF       R0+0, 0
	XORLW      255
	BTFSS      STATUS+0, 2
	GOTO       L__Delay_Load7
	CLRF       Delay_Load_tmpHi+0
L__Delay_Load7:
;electronique_chenillard_012_16f628.mpas,80 :: 		iDelayStop := (256 * tmpHi) + tmpLo;
	MOVF       Delay_Load_tmpHi+0, 0
	MOVWF      _iDelayStop+1
	CLRF       _iDelayStop+0
	MOVF       Delay_Load_tmpLo+0, 0
	ADDWF      _iDelayStop+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDelayStop+1, 1
;electronique_chenillard_012_16f628.mpas,81 :: 		end;
	RETURN
; end of _Delay_Load

_GetDelayStart:

;electronique_chenillard_012_16f628.mpas,84 :: 		begin
;electronique_chenillard_012_16f628.mpas,85 :: 		result := 150;
	MOVLW      150
	MOVWF      R2+0
	CLRF       R2+1
;electronique_chenillard_012_16f628.mpas,86 :: 		end;
	MOVF       R2+0, 0
	MOVWF      R0+0
	MOVF       R2+1, 0
	MOVWF      R0+1
	RETURN
; end of _GetDelayStart

_GetDelayStop:

;electronique_chenillard_012_16f628.mpas,89 :: 		begin
;electronique_chenillard_012_16f628.mpas,90 :: 		result := 150;
	MOVLW      150
	MOVWF      R2+0
	CLRF       R2+1
;electronique_chenillard_012_16f628.mpas,91 :: 		end;
	MOVF       R2+0, 0
	MOVWF      R0+0
	MOVF       R2+1, 0
	MOVWF      R0+1
	RETURN
; end of _GetDelayStop

_Out_Set:

;electronique_chenillard_012_16f628.mpas,94 :: 		begin
;electronique_chenillard_012_16f628.mpas,95 :: 		bRunning := true;
	MOVLW      255
	MOVWF      _bRunning+0
;electronique_chenillard_012_16f628.mpas,96 :: 		Out_1 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set131
	BCF        RB4_bit+0, 4
	GOTO       L__Out_Set132
L__Out_Set131:
	BSF        RB4_bit+0, 4
L__Out_Set132:
;electronique_chenillard_012_16f628.mpas,97 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,98 :: 		Out_2 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set133
	BCF        RB5_bit+0, 5
	GOTO       L__Out_Set134
L__Out_Set133:
	BSF        RB5_bit+0, 5
L__Out_Set134:
;electronique_chenillard_012_16f628.mpas,99 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,100 :: 		Out_3 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set135
	BCF        RB3_bit+0, 3
	GOTO       L__Out_Set136
L__Out_Set135:
	BSF        RB3_bit+0, 3
L__Out_Set136:
;electronique_chenillard_012_16f628.mpas,101 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,102 :: 		Out_4 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set137
	BCF        RB2_bit+0, 2
	GOTO       L__Out_Set138
L__Out_Set137:
	BSF        RB2_bit+0, 2
L__Out_Set138:
;electronique_chenillard_012_16f628.mpas,103 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,104 :: 		Out_5 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set139
	BCF        RB1_bit+0, 1
	GOTO       L__Out_Set140
L__Out_Set139:
	BSF        RB1_bit+0, 1
L__Out_Set140:
;electronique_chenillard_012_16f628.mpas,105 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,106 :: 		Out_6 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set141
	BCF        RB0_bit+0, 0
	GOTO       L__Out_Set142
L__Out_Set141:
	BSF        RB0_bit+0, 0
L__Out_Set142:
;electronique_chenillard_012_16f628.mpas,107 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,108 :: 		Out_7 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set143
	BCF        RA3_bit+0, 3
	GOTO       L__Out_Set144
L__Out_Set143:
	BSF        RA3_bit+0, 3
L__Out_Set144:
;electronique_chenillard_012_16f628.mpas,109 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,110 :: 		Out_8 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set145
	BCF        RA2_bit+0, 2
	GOTO       L__Out_Set146
L__Out_Set145:
	BSF        RA2_bit+0, 2
L__Out_Set146:
;electronique_chenillard_012_16f628.mpas,111 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,112 :: 		Out_9 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set147
	BCF        RA1_bit+0, 1
	GOTO       L__Out_Set148
L__Out_Set147:
	BSF        RA1_bit+0, 1
L__Out_Set148:
;electronique_chenillard_012_16f628.mpas,113 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,114 :: 		Out_10 := bState;
	BTFSC      FARG_Out_Set_bState+0, 0
	GOTO       L__Out_Set149
	BCF        RA0_bit+0, 0
	GOTO       L__Out_Set150
L__Out_Set149:
	BSF        RA0_bit+0, 0
L__Out_Set150:
;electronique_chenillard_012_16f628.mpas,115 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,116 :: 		bRunning := false;
	CLRF       _bRunning+0
;electronique_chenillard_012_16f628.mpas,117 :: 		end;
	RETURN
; end of _Out_Set

_Out_Set_Rev:

;electronique_chenillard_012_16f628.mpas,120 :: 		begin
;electronique_chenillard_012_16f628.mpas,121 :: 		bRunning := true;
	MOVLW      255
	MOVWF      _bRunning+0
;electronique_chenillard_012_16f628.mpas,122 :: 		Out_10 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev151
	BCF        RA0_bit+0, 0
	GOTO       L__Out_Set_Rev152
L__Out_Set_Rev151:
	BSF        RA0_bit+0, 0
L__Out_Set_Rev152:
;electronique_chenillard_012_16f628.mpas,123 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,124 :: 		Out_9 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev153
	BCF        RA1_bit+0, 1
	GOTO       L__Out_Set_Rev154
L__Out_Set_Rev153:
	BSF        RA1_bit+0, 1
L__Out_Set_Rev154:
;electronique_chenillard_012_16f628.mpas,125 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,126 :: 		Out_8 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev155
	BCF        RA2_bit+0, 2
	GOTO       L__Out_Set_Rev156
L__Out_Set_Rev155:
	BSF        RA2_bit+0, 2
L__Out_Set_Rev156:
;electronique_chenillard_012_16f628.mpas,127 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,128 :: 		Out_7 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev157
	BCF        RA3_bit+0, 3
	GOTO       L__Out_Set_Rev158
L__Out_Set_Rev157:
	BSF        RA3_bit+0, 3
L__Out_Set_Rev158:
;electronique_chenillard_012_16f628.mpas,129 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,130 :: 		Out_6 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev159
	BCF        RB0_bit+0, 0
	GOTO       L__Out_Set_Rev160
L__Out_Set_Rev159:
	BSF        RB0_bit+0, 0
L__Out_Set_Rev160:
;electronique_chenillard_012_16f628.mpas,131 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,132 :: 		Out_5 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev161
	BCF        RB1_bit+0, 1
	GOTO       L__Out_Set_Rev162
L__Out_Set_Rev161:
	BSF        RB1_bit+0, 1
L__Out_Set_Rev162:
;electronique_chenillard_012_16f628.mpas,133 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,134 :: 		Out_4 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev163
	BCF        RB2_bit+0, 2
	GOTO       L__Out_Set_Rev164
L__Out_Set_Rev163:
	BSF        RB2_bit+0, 2
L__Out_Set_Rev164:
;electronique_chenillard_012_16f628.mpas,135 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,136 :: 		Out_3 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev165
	BCF        RB3_bit+0, 3
	GOTO       L__Out_Set_Rev166
L__Out_Set_Rev165:
	BSF        RB3_bit+0, 3
L__Out_Set_Rev166:
;electronique_chenillard_012_16f628.mpas,137 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,138 :: 		Out_2 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev167
	BCF        RB5_bit+0, 5
	GOTO       L__Out_Set_Rev168
L__Out_Set_Rev167:
	BSF        RB5_bit+0, 5
L__Out_Set_Rev168:
;electronique_chenillard_012_16f628.mpas,139 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,140 :: 		Out_1 := bState;
	BTFSC      FARG_Out_Set_Rev_bState+0, 0
	GOTO       L__Out_Set_Rev169
	BCF        RB4_bit+0, 4
	GOTO       L__Out_Set_Rev170
L__Out_Set_Rev169:
	BSF        RB4_bit+0, 4
L__Out_Set_Rev170:
;electronique_chenillard_012_16f628.mpas,141 :: 		VDelay_ms(iDelay);
	MOVF       FARG_Out_Set_Rev_iDelay+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       FARG_Out_Set_Rev_iDelay+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_chenillard_012_16f628.mpas,142 :: 		bRunning := false;
	CLRF       _bRunning+0
;electronique_chenillard_012_16f628.mpas,143 :: 		end;
	RETURN
; end of _Out_Set_Rev

_Start:

;electronique_chenillard_012_16f628.mpas,146 :: 		begin
;electronique_chenillard_012_16f628.mpas,147 :: 		bStart := false;
	CLRF       _bStart+0
;electronique_chenillard_012_16f628.mpas,148 :: 		bStarted := true;
	MOVLW      255
	MOVWF      _bStarted+0
;electronique_chenillard_012_16f628.mpas,149 :: 		if bReverse then
	MOVF       _bReverse+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Start15
;electronique_chenillard_012_16f628.mpas,150 :: 		Out_Set(true, iDelayStart)
	MOVLW      255
	MOVWF      FARG_Out_Set_bState+0
	MOVF       _iDelayStart+0, 0
	MOVWF      FARG_Out_Set_iDelay+0
	MOVF       _iDelayStart+1, 0
	MOVWF      FARG_Out_Set_iDelay+1
	CALL       _Out_Set+0
	GOTO       L__Start16
;electronique_chenillard_012_16f628.mpas,151 :: 		else
L__Start15:
;electronique_chenillard_012_16f628.mpas,152 :: 		Out_Set_Rev(true, iDelayStart);
	MOVLW      255
	MOVWF      FARG_Out_Set_Rev_bState+0
	MOVF       _iDelayStart+0, 0
	MOVWF      FARG_Out_Set_Rev_iDelay+0
	MOVF       _iDelayStart+1, 0
	MOVWF      FARG_Out_Set_Rev_iDelay+1
	CALL       _Out_Set_Rev+0
L__Start16:
;electronique_chenillard_012_16f628.mpas,153 :: 		end;
	RETURN
; end of _Start

_Stop:

;electronique_chenillard_012_16f628.mpas,156 :: 		begin
;electronique_chenillard_012_16f628.mpas,157 :: 		bStop := false;
	CLRF       _bStop+0
;electronique_chenillard_012_16f628.mpas,158 :: 		if bReverse then
	MOVF       _bReverse+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Stop19
;electronique_chenillard_012_16f628.mpas,159 :: 		Out_Set(false, iDelayStop)
	CLRF       FARG_Out_Set_bState+0
	MOVF       _iDelayStop+0, 0
	MOVWF      FARG_Out_Set_iDelay+0
	MOVF       _iDelayStop+1, 0
	MOVWF      FARG_Out_Set_iDelay+1
	CALL       _Out_Set+0
	GOTO       L__Stop20
;electronique_chenillard_012_16f628.mpas,160 :: 		else
L__Stop19:
;electronique_chenillard_012_16f628.mpas,161 :: 		Out_Set_Rev(false, iDelayStop);
	CLRF       FARG_Out_Set_Rev_bState+0
	MOVF       _iDelayStop+0, 0
	MOVWF      FARG_Out_Set_Rev_iDelay+0
	MOVF       _iDelayStop+1, 0
	MOVWF      FARG_Out_Set_Rev_iDelay+1
	CALL       _Out_Set_Rev+0
L__Stop20:
;electronique_chenillard_012_16f628.mpas,162 :: 		bStarted := false;
	CLRF       _bStarted+0
;electronique_chenillard_012_16f628.mpas,163 :: 		end;
	RETURN
; end of _Stop

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_chenillard_012_16f628.mpas,166 :: 		begin
;electronique_chenillard_012_16f628.mpas,167 :: 		if TestBit(INTCON, RBIF) = 1 then
	CLRF       R1+0
	BTFSS      INTCON+0, 0
	GOTO       L__Interrupt25
	MOVLW      1
	MOVWF      R1+0
L__Interrupt25:
	MOVF       R1+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt23
;electronique_chenillard_012_16f628.mpas,169 :: 		if In_Stop = 0 then
	BTFSC      RB6_bit+0, 6
	GOTO       L__Interrupt27
;electronique_chenillard_012_16f628.mpas,171 :: 		if ((not bStarted) and (In_Rev = 1)) then
	COMF       _bStarted+0, 0
	MOVWF      R1+0
	BTFSC      RA6_bit+0, 6
	GOTO       L__Interrupt172
	BCF        3, 0
	GOTO       L__Interrupt173
L__Interrupt172:
	BSF        3, 0
L__Interrupt173:
	CLRF       R0+0
	BTFSC      3, 0
	INCF       R0+0, 1
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt30
;electronique_chenillard_012_16f628.mpas,173 :: 		bStart := true;
	MOVLW      255
	MOVWF      _bStart+0
;electronique_chenillard_012_16f628.mpas,174 :: 		bReverse := true;
	MOVLW      255
	MOVWF      _bReverse+0
;electronique_chenillard_012_16f628.mpas,175 :: 		end
	GOTO       L__Interrupt31
;electronique_chenillard_012_16f628.mpas,176 :: 		else if (bStarted and (not bReverse)) then
L__Interrupt30:
	COMF       _bReverse+0, 0
	MOVWF      R0+0
	MOVF       _bStarted+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt33
;electronique_chenillard_012_16f628.mpas,177 :: 		bStop := true
	MOVLW      255
	MOVWF      _bStop+0
	GOTO       L__Interrupt34
;electronique_chenillard_012_16f628.mpas,178 :: 		else if (bStarted and bReverse) then
L__Interrupt33:
	MOVF       _bReverse+0, 0
	ANDWF      _bStarted+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt36
;electronique_chenillard_012_16f628.mpas,179 :: 		nop;  // ignore change
	NOP
L__Interrupt36:
L__Interrupt34:
L__Interrupt31:
;electronique_chenillard_012_16f628.mpas,180 :: 		end
	GOTO       L__Interrupt28
;electronique_chenillard_012_16f628.mpas,181 :: 		else if In_Start = 0 then
L__Interrupt27:
	BTFSC      RB7_bit+0, 7
	GOTO       L__Interrupt39
;electronique_chenillard_012_16f628.mpas,183 :: 		if (not bStarted) then
	COMF       _bStarted+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt42
;electronique_chenillard_012_16f628.mpas,185 :: 		bStart := true;
	MOVLW      255
	MOVWF      _bStart+0
;electronique_chenillard_012_16f628.mpas,186 :: 		bReverse := false;
	CLRF       _bReverse+0
;electronique_chenillard_012_16f628.mpas,187 :: 		end
	GOTO       L__Interrupt43
;electronique_chenillard_012_16f628.mpas,188 :: 		else if (bStarted and (not bReverse)) then
L__Interrupt42:
	COMF       _bReverse+0, 0
	MOVWF      R0+0
	MOVF       _bStarted+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt45
;electronique_chenillard_012_16f628.mpas,189 :: 		nop  // ignore change
	NOP
	GOTO       L__Interrupt46
;electronique_chenillard_012_16f628.mpas,190 :: 		else if (bStarted and bReverse) then
L__Interrupt45:
	MOVF       _bReverse+0, 0
	ANDWF      _bStarted+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt48
;electronique_chenillard_012_16f628.mpas,191 :: 		bStop := true
	MOVLW      255
	MOVWF      _bStop+0
L__Interrupt48:
L__Interrupt46:
L__Interrupt43:
;electronique_chenillard_012_16f628.mpas,192 :: 		end;
L__Interrupt39:
L__Interrupt28:
;electronique_chenillard_012_16f628.mpas,193 :: 		ClearBit(INTCON, RBIF);
	BCF        INTCON+0, 0
;electronique_chenillard_012_16f628.mpas,194 :: 		end;
L__Interrupt23:
;electronique_chenillard_012_16f628.mpas,195 :: 		end;
L__Interrupt171:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_Led_Blink:

;electronique_chenillard_012_16f628.mpas,200 :: 		begin
;electronique_chenillard_012_16f628.mpas,201 :: 		for i := 1 to 2 do
	MOVLW      1
	MOVWF      Led_Blink_i+0
L__Led_Blink52:
;electronique_chenillard_012_16f628.mpas,203 :: 		Out_Led := 1;
	BSF        RA7_bit+0, 7
;electronique_chenillard_012_16f628.mpas,205 :: 		1 : VDelay_ms(iDelayStart);
	MOVF       _iMode+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__Led_Blink59
	MOVF       _iDelayStart+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       _iDelayStart+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
	GOTO       L__Led_Blink56
L__Led_Blink59:
;electronique_chenillard_012_16f628.mpas,206 :: 		2 : VDelay_ms(iDelayStop);
	MOVF       _iMode+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__Led_Blink62
	MOVF       _iDelayStop+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       _iDelayStop+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
	GOTO       L__Led_Blink56
L__Led_Blink62:
L__Led_Blink56:
;electronique_chenillard_012_16f628.mpas,208 :: 		Out_Led := 0;
	BCF        RA7_bit+0, 7
;electronique_chenillard_012_16f628.mpas,210 :: 		1 : VDelay_ms(iDelayStart);
	MOVF       _iMode+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__Led_Blink66
	MOVF       _iDelayStart+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       _iDelayStart+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
	GOTO       L__Led_Blink63
L__Led_Blink66:
;electronique_chenillard_012_16f628.mpas,211 :: 		2 : VDelay_ms(iDelayStop);
	MOVF       _iMode+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__Led_Blink69
	MOVF       _iDelayStop+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	MOVF       _iDelayStop+1, 0
	MOVWF      FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
	GOTO       L__Led_Blink63
L__Led_Blink69:
L__Led_Blink63:
;electronique_chenillard_012_16f628.mpas,213 :: 		end;
	MOVF       Led_Blink_i+0, 0
	XORLW      2
	BTFSC      STATUS+0, 2
	GOTO       L__Led_Blink55
	INCF       Led_Blink_i+0, 1
	GOTO       L__Led_Blink52
L__Led_Blink55:
;electronique_chenillard_012_16f628.mpas,214 :: 		end;
	RETURN
; end of _Led_Blink

_main:

;electronique_chenillard_012_16f628.mpas,216 :: 		begin
;electronique_chenillard_012_16f628.mpas,217 :: 		Init;
	CALL       _Init+0
;electronique_chenillard_012_16f628.mpas,218 :: 		Delay_Load;
	CALL       _Delay_Load+0
;electronique_chenillard_012_16f628.mpas,219 :: 		Led_Blink;
	CALL       _Led_Blink+0
;electronique_chenillard_012_16f628.mpas,220 :: 		while true do
L__main72:
;electronique_chenillard_012_16f628.mpas,224 :: 		if Button(PORTA, 4, 100, 0) and (bProg = false) then
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      4
	MOVWF      FARG_Button_pin+0
	MOVLW      100
	MOVWF      FARG_Button_time+0
	CLRF       FARG_Button_activeState+0
	CALL       _Button+0
	MOVF       _bProg+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main77
;electronique_chenillard_012_16f628.mpas,226 :: 		if iMode < 2 then
	MOVLW      2
	SUBWF      _iMode+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main80
;electronique_chenillard_012_16f628.mpas,227 :: 		inc(iMode)
	INCF       _iMode+0, 1
	GOTO       L__main81
;electronique_chenillard_012_16f628.mpas,228 :: 		else
L__main80:
;electronique_chenillard_012_16f628.mpas,229 :: 		iMode := 0;
	CLRF       _iMode+0
L__main81:
;electronique_chenillard_012_16f628.mpas,230 :: 		bProg := true;
	MOVLW      255
	MOVWF      _bProg+0
;electronique_chenillard_012_16f628.mpas,231 :: 		Out_Led := (iMode > 0);
	MOVF       _iMode+0, 0
	SUBLW      0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__main174
	BCF        RA7_bit+0, 7
	GOTO       L__main175
L__main174:
	BSF        RA7_bit+0, 7
L__main175:
;electronique_chenillard_012_16f628.mpas,233 :: 		0 : Delay_Save
	MOVF       _iMode+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main85
	CALL       _Delay_Save+0
;electronique_chenillard_012_16f628.mpas,234 :: 		else Led_Blink;
	GOTO       L__main82
L__main85:
	CALL       _Led_Blink+0
L__main82:
;electronique_chenillard_012_16f628.mpas,236 :: 		end;
L__main77:
;electronique_chenillard_012_16f628.mpas,237 :: 		if PORTA.4 = 1 then bProg := false;
	BTFSS      PORTA+0, 4
	GOTO       L__main87
	CLRF       _bProg+0
L__main87:
;electronique_chenillard_012_16f628.mpas,240 :: 		if (bStart and (iMode = 0) and (not bStarted)) then
	MOVF       _iMode+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      _bStart+0, 0
	MOVWF      R1+0
	COMF       _bStarted+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main90
;electronique_chenillard_012_16f628.mpas,241 :: 		Start;
	CALL       _Start+0
L__main90:
;electronique_chenillard_012_16f628.mpas,244 :: 		if (bStop and (iMode = 0) and bStarted) then
	MOVF       _iMode+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       _bStop+0, 0
	ANDWF      R0+0, 1
	MOVF       _bStarted+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main93
;electronique_chenillard_012_16f628.mpas,245 :: 		Stop;
	CALL       _Stop+0
L__main93:
;electronique_chenillard_012_16f628.mpas,248 :: 		if iMode > 0 then
	MOVF       _iMode+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__main96
;electronique_chenillard_012_16f628.mpas,251 :: 		if Button(PORTB, 7, 100, 0) then
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      7
	MOVWF      FARG_Button_pin+0
	MOVLW      100
	MOVWF      FARG_Button_time+0
	CLRF       FARG_Button_activeState+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main99
;electronique_chenillard_012_16f628.mpas,254 :: 		1 : begin
	MOVF       _iMode+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main104
;electronique_chenillard_012_16f628.mpas,255 :: 		if iDelayStart < 1000 then
	MOVLW      3
	SUBWF      _iDelayStart+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main176
	MOVLW      232
	SUBWF      _iDelayStart+0, 0
L__main176:
	BTFSC      STATUS+0, 0
	GOTO       L__main106
;electronique_chenillard_012_16f628.mpas,256 :: 		iDelayStart := iDelayStart + 100
	MOVLW      100
	ADDWF      _iDelayStart+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDelayStart+1, 1
	GOTO       L__main107
;electronique_chenillard_012_16f628.mpas,257 :: 		else
L__main106:
;electronique_chenillard_012_16f628.mpas,258 :: 		iDelayStart := 100;
	MOVLW      100
	MOVWF      _iDelayStart+0
	CLRF       _iDelayStart+1
L__main107:
;electronique_chenillard_012_16f628.mpas,259 :: 		Led_Blink;
	CALL       _Led_Blink+0
;electronique_chenillard_012_16f628.mpas,260 :: 		end;
	GOTO       L__main101
L__main104:
;electronique_chenillard_012_16f628.mpas,261 :: 		2 : begin
	MOVF       _iMode+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main110
;electronique_chenillard_012_16f628.mpas,262 :: 		if iDelayStop < 2000 then
	MOVLW      7
	SUBWF      _iDelayStop+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main177
	MOVLW      208
	SUBWF      _iDelayStop+0, 0
L__main177:
	BTFSC      STATUS+0, 0
	GOTO       L__main112
;electronique_chenillard_012_16f628.mpas,263 :: 		iDelayStop := iDelayStop + 100
	MOVLW      100
	ADDWF      _iDelayStop+0, 1
	BTFSC      STATUS+0, 0
	INCF       _iDelayStop+1, 1
	GOTO       L__main113
;electronique_chenillard_012_16f628.mpas,264 :: 		else
L__main112:
;electronique_chenillard_012_16f628.mpas,265 :: 		iDelayStop := 100;
	MOVLW      100
	MOVWF      _iDelayStop+0
	CLRF       _iDelayStop+1
L__main113:
;electronique_chenillard_012_16f628.mpas,266 :: 		Led_Blink;
	CALL       _Led_Blink+0
;electronique_chenillard_012_16f628.mpas,267 :: 		end;
	GOTO       L__main101
L__main110:
L__main101:
;electronique_chenillard_012_16f628.mpas,269 :: 		end;
L__main99:
;electronique_chenillard_012_16f628.mpas,271 :: 		if Button(PORTB, 6, 100, 0) then
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      6
	MOVWF      FARG_Button_pin+0
	MOVLW      100
	MOVWF      FARG_Button_time+0
	CLRF       FARG_Button_activeState+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main115
;electronique_chenillard_012_16f628.mpas,274 :: 		1 : begin
	MOVF       _iMode+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main120
;electronique_chenillard_012_16f628.mpas,275 :: 		if iDelayStart > 100 then
	MOVF       _iDelayStart+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main178
	MOVF       _iDelayStart+0, 0
	SUBLW      100
L__main178:
	BTFSC      STATUS+0, 0
	GOTO       L__main122
;electronique_chenillard_012_16f628.mpas,276 :: 		iDelayStart := iDelayStart - 100
	MOVLW      100
	SUBWF      _iDelayStart+0, 1
	BTFSS      STATUS+0, 0
	DECF       _iDelayStart+1, 1
	GOTO       L__main123
;electronique_chenillard_012_16f628.mpas,277 :: 		else
L__main122:
;electronique_chenillard_012_16f628.mpas,278 :: 		iDelayStart := 1000;
	MOVLW      232
	MOVWF      _iDelayStart+0
	MOVLW      3
	MOVWF      _iDelayStart+1
L__main123:
;electronique_chenillard_012_16f628.mpas,279 :: 		Led_Blink;
	CALL       _Led_Blink+0
;electronique_chenillard_012_16f628.mpas,280 :: 		end;
	GOTO       L__main117
L__main120:
;electronique_chenillard_012_16f628.mpas,281 :: 		2 : begin
	MOVF       _iMode+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main126
;electronique_chenillard_012_16f628.mpas,282 :: 		if iDelayStop > 100 then
	MOVF       _iDelayStop+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main179
	MOVF       _iDelayStop+0, 0
	SUBLW      100
L__main179:
	BTFSC      STATUS+0, 0
	GOTO       L__main128
;electronique_chenillard_012_16f628.mpas,283 :: 		iDelayStop := iDelayStop - 100
	MOVLW      100
	SUBWF      _iDelayStop+0, 1
	BTFSS      STATUS+0, 0
	DECF       _iDelayStop+1, 1
	GOTO       L__main129
;electronique_chenillard_012_16f628.mpas,284 :: 		else
L__main128:
;electronique_chenillard_012_16f628.mpas,285 :: 		iDelayStop := 2000;
	MOVLW      208
	MOVWF      _iDelayStop+0
	MOVLW      7
	MOVWF      _iDelayStop+1
L__main129:
;electronique_chenillard_012_16f628.mpas,286 :: 		Led_Blink;
	CALL       _Led_Blink+0
;electronique_chenillard_012_16f628.mpas,287 :: 		end;
	GOTO       L__main117
L__main126:
L__main117:
;electronique_chenillard_012_16f628.mpas,289 :: 		end;
L__main115:
;electronique_chenillard_012_16f628.mpas,290 :: 		end;
L__main96:
;electronique_chenillard_012_16f628.mpas,292 :: 		Delay_ms(50);
	MOVLW      65
	MOVWF      R12+0
	MOVLW      238
	MOVWF      R13+0
L__main130:
	DECFSZ     R13+0, 1
	GOTO       L__main130
	DECFSZ     R12+0, 1
	GOTO       L__main130
	NOP
;electronique_chenillard_012_16f628.mpas,293 :: 		end;
	GOTO       L__main72
;electronique_chenillard_012_16f628.mpas,294 :: 		end.
	GOTO       $+0
; end of _main
